accounts/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path("signup/", views.SignUpView.as_view(), name="signup"),
]

blog/urls.py
from django.urls import path
from . import views

app_name = "blog"

urlpatterns = [
    path("post/", views.BlogListView.as_view(), name="blog_list_home"),
    path("post/<int:pk>/", views.BlogDetailView.as_view(), name="post_detail"),
    path("post/new/", views.BlogCreateView.as_view(), name="post_new"),
    path("post/<int:pk>/update/", views.BlogUpdateView.as_view(), name="post_update"),
    path("post/<int:pk>/delete/", views.BlogDeleteView.as_view(), name="post_delete"),

]

newspaper/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path("accounts/", include("django.contrib.auth.urls")),
    # path("accounts/", include("accounts.urls")),
    path("users/", include("users.urls", namespace="users")),


    path("", include("pages.urls", namespace="pages")),
    path("", include("blog.urls", namespace="blog")),
]

pages/urls.py
from django.urls import path

from . import views

app_name = "pages"
urlpatterns = [
    path("", views.HomePageView.as_view(), name="home"),
    path("about/", views.AboutPageView.as_view(), name="about")

]

users/urls.py
from django.urls import path

from . import views

app_name = "users"
urlpatterns = [
    path("signup/", views.SignUpView.as_view(), name="signup"),
]

accounts/models.py
from django.db import models

# Create your models here.

blog/models.py
from django.db import models
from django.shortcuts import reverse
from django.contrib.auth import get_user_model
User = get_user_model()

class Post(models.Model):
    author          = models.ForeignKey(User, on_delete=models.CASCADE)
    title           = models.CharField(max_length=100)
    body            = models.TextField()
    created_at      = models.DateTimeField(auto_now_add=True)
    updated_at      = models.DateTimeField(auto_now=True)
    
    class Meta:
        verbose_name = "Post"
        verbose_name_plural = "Posts"

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse("blog:post_detail", kwargs={"pk": self.pk})  #args=[str(self.id)] can be used instead of kwargs.


class Comment(models.Model):
    article             = models.ForeignKey(Post, related_name="comments", on_delete=models.CASCADE)
    author              = models.ForeignKey(get_user_model(), on_delete=models.CASCADE)
    comment             = models.CharField(max_length=150)
    created_at          = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.comment
    
    def get_absolute_url(self):
        return reverse("blog:post_detail", kwargs={"pk": self.article})
    

pages/models.py
from django.db import models

# Create your models here.

users/models.py
from django.db import models
from django.contrib.auth.models import AbstractUser
# Create your models here.
class CustomUser(AbstractUser):
    age = models.PositiveIntegerField(null=True, blank=True)

blog/forms.py
from django import forms

from . import models

class CommentForm(forms.ModelForm):
    class Meta:
        model = models.Comment
        fields = ('comment',)

users/forms.py
from django.contrib.auth.forms import UserCreationForm, UserChangeForm
from django import forms

from . import models

class CustomUserCreationForm(UserCreationForm):
    class Meta(UserCreationForm.Meta):
        model = models.CustomUser
        # fields = UserCreationForm.Meta.fields + ("age",)
        fields = ["username", 'email', 'age']

class CustomUserChangeForm(UserChangeForm):
    class Meta:
        model = models.CustomUser
        # fields = UserChangeForm.Meta.fields
        fields = ["username", 'email', 'age']

        

accounts/views.py
from django.urls import reverse_lazy
from django.shortcuts import render
from django.contrib.auth.forms import UserCreationForm
from django.views.generic.edit import CreateView


class SignUpView(CreateView):
    form_class = UserCreationForm
    success_url = reverse_lazy("login")
    template_name = "registration/signup.html"

    

blog/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.exceptions import PermissionDenied
from django.shortcuts import render
from django.views.generic import TemplateView, ListView, DetailView
from django.views.generic.edit import CreateView, UpdateView, DeleteView, FormMixin
from django.urls import reverse_lazy, reverse
from django.http import HttpResponseForbidden


from . import models
from .forms import CommentForm

class BlogListView(ListView):
    model = models.Post
    template_name= "blog/blog_list_home.html"

class BlogDetailView(FormMixin, DetailView):
    model = models.Post
    context_object_name = "post"
    form_class = CommentForm

    def get_success_url(self):
        return reverse("blog:post_detail", kwargs={'pk':self.object.pk})
            
    def post(self, request, *args, **kwargs):
        if not request.user.is_authenticated:
            return HttpResponseForbidden()
        self.object = self.get_object()
        form = self.get_form()
        form.article = self.object
        if form.is_valid():
            return self.form_valid(form)
        else:
            return self.form_invalid(form)

    def form_valid(self, form):
        f = form.save(commit=False)
        f.author = self.request.user
        f.article = self.get_object()
        f.save()
        return super().form_valid(form)
    

class BlogCreateView(LoginRequiredMixin, CreateView):
    model = models.Post
    fields = ("title","body")
    template_name = "blog/post_form.html"
    login_url = "login"

    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)

class BlogUpdateView(LoginRequiredMixin, UpdateView):
    model = models.Post
    fields = ["title",'body']
    template_name = "blog/post_form.html"

    def dispatch(self, request, *args, **kwargs):
        obj = self.get_object()
        if request.user != obj.author:
            raise PermissionDenied
        return super().dispatch(request, *args, **kwargs)

class BlogDeleteView(LoginRequiredMixin, DeleteView):
    model = models.Post
    template_name = "blog/post_delete.html"
    success_url = reverse_lazy("blog:blog_list_home") 

    def dispatch(self, request, *args, **kwargs):
        obj = self.get_object()
        if request.user != obj.author:
            raise PermissionDenied
        return super().dispatch(request, *args, **kwargs)

pages/views.py
from django.shortcuts import render
from django.views.generic import TemplateView

# Create your views here.
class HomePageView(TemplateView):
    template_name = "pages/home.html"

class AboutPageView(TemplateView):
    template_name = "pages/about.html"

users/views.py
from django.urls import reverse_lazy
from django.shortcuts import render
from django.views.generic.edit import CreateView

from . import forms

class SignUpView(CreateView):
    form_class = forms.CustomUserCreationForm
    success_url = reverse_lazy("login")
    template_name = "registration/signup.html"

    

templates/base/base.html
{% load static %}

<!doctype html>
<html lang="en">

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="shortcut icon" href="">
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>{% block title %}Replace this title !!{% endblock title %}</title>
    <link rel="stylesheet" href="{% static 'css/base.css' %}">
</head>

<body>
    <div class="container">
        {% include "base/snippets/navbar.html" %}

    {% block content %}
    {% endblock content %}
    </div>

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
        integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
        integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
        integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
        crossorigin="anonymous"></script>
</body>

</html>

templates/base/snippets/navbar.html
<nav class="navbar sticky-top navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand" href="/">Newspaper</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <a class="nav-link" href="{% url "pages:home" %}">Home</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{% url "pages:about"%}">About</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{% url "blog:blog_list_home"%}">Blogs</a>
      </li> 
    </ul>
    
    {% if request.user.is_authenticated %}
      <div class="nav-item dropdown ml-auto">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          {{request.user.username}}
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="{% url 'password_change' %}">Change Password</a>
          <a class="dropdown-item" href="{% url "logout" %}">Logout</a>
        </div>
      </div>
      {% else %}
      <form class="form-inline ml-auto">
        <a class="btn btn-outline-secondary" href="{% url "login"%}">Log In</a>
        <a class="btn btn-primary ml-2" href="{% url "users:signup"%}">Sign Up</a>
      </form>
      {% endif %}
  </div>
</nav>
<br>

templates/blog/blog_list_home.html
{% extends 'base/base.html' %}

{% block title %}Blog Home{% endblock title %}

{% block content %}

{% comment %} <small>object_list or post_list</small> {% endcomment %}
{% if request.user.is_authenticated %}
    <h2><a href="{% url 'blog:post_new' %}">+ New Blog</a></h2>
    <hr>
{% endif %}


{% for post in post_list %}
    {% comment %} <h3><a href='{% url "blog:post_detail" post.pk %}'>{{post.title}}</a></h3> {% endcomment %}
    <h3><a href='{{ post.get_absolute_url }}'>{{post.title}}</a></h3>
    <span>
        {% if post.comments.all %}
            {{ post.comments.all|length}} comments
        {% endif %}
    </span>
{% endfor %}

{% endblock content %}

templates/blog/post_delete.html
{% extends 'base/base.html' %}

{% block title %}Delete Post{% endblock title %}

{% block content %}

<form method="post">
    {% csrf_token %}
        <p>Are you sure you want to delete "{{object.title}}" ?</p>
        <button type="submit" class="btn btn-danger ml-2">Confirm</button>
</form>

{% endblock content %}

templates/blog/post_detail.html
{% extends 'base/base.html' %}
{% load crispy_forms_tags %}
{% block title %}Blog Detail{% endblock title %}

{% block content %}

{% comment %} <small>object or post</small> {% endcomment %}
<h2>{{post.title}}</h2>
<small>by {{post.author}}</small>
<p>{{post.body}}</p>
<a href="{% url 'blog:post_update' post.pk %}">Edit</a> | <a href="{% url 'blog:post_delete' post.pk %}">Delete</a>
<hr>
<h5><u>Comments</u></h5>
<form method="post">
    {% csrf_token %}
    {{form|crispy}}
    <button class="btn btn-secondary" type="submit">Post Comment</button>
</form>
<table>
    {% for comment in post.comments.all %}
        <tr>
            <td>{{ comment.author.username }}</td>
            <td>({{comment.created_at|timesince}} ago) :</td>
            <td>{{comment.comment}}</td>
        </tr>
    {% endfor %}
</table>
{% endblock content %}

templates/blog/post_form.html
{% extends 'base/base.html' %}

{% block title %}Blog Form{% endblock title %}

{% block content %}

<form method="post">
    {% csrf_token %}
    <table>
        {{form.as_table}}
    </table>
        <input type="submit" value="Submit">
</form>

{% endblock content %}

templates/pages/about.html
{% extends 'base/base.html' %}

{% block title %}About Page
{% endblock title %}

{% block content %}
    <h3> About Information </h3>
{% endblock content %}

templates/pages/home.html
{% extends 'base/base.html' %}

{% block title %}Home Page
{% endblock title %}

{% block content %}

<div class="jumbotron">
  <h1 class="display-4">Newspaper App</h1>
  <p class="lead">...cause “The newspaper is a greater treasure to the people than uncounted millions of gold.”-
Henry Ward Beecher</p>
  <hr class="my-4">
  <p>Browse through all the quality posts.</p>
  <p class="lead">
    <a class="btn btn-primary btn-lg" href="{% url 'blog:blog_list_home' %}" role="button">View all articles</a>
  </p>
</div>

{% endblock content %}